#include <QString>
#include <QByteArray>
#include <QTest>

#include "commontest.h"
#include "strhelp.h"

void CommonTest::testStrBase64Decode() {
    char garbage[1000];
    char *data = NULL;
    size_t data_size = 0;
    int ret;
    for (int i = 0; i < 1000; i++) {
        garbage[i] = (char) qrand() % 255;
    }

    QByteArray ba(garbage, 1000);

    QByteArray baB64 = ba.toBase64();

    ret = str_base64_decode(&data, &data_size, (char *)baB64.constData(), baB64.size());

    QVERIFY(ret == 0);
    QVERIFY(data_size == 1000);

    for (size_t i = 0; i < data_size; i++) {
        QVERIFY(garbage[i] == data[i]);
    }
    free (data);
}

QTEST_GUILESS_MAIN (CommonTest);
